Attribute VB_Name = "Module1"
'Modem Status Flags
Const MS_CTS_ON = &H10&
Const MS_DSR_ON = &H20&
Const MS_RING_ON = &H40&
Const MS_RLSD_ON = &H80&
 
'Escape Functions
Const SETXOFF = 1 '  Simulate XOFF received
Const SETXON = 2 '  Simulate XON received
Const SETRTS = 3 '  Set RTS high
Const CLRRTS = 4 '  Set RTS low
Const SETDTR = 5 '  Set DTR high
Const CLRDTR = 6 '  Set DTR low
Const RESETDEV = 7 '  Reset device if possible
Const SETBREAK = 8 'Set the device break line
Const CLRBREAK = 9 ' Clear the device break line

Const GENERIC_READ = &H80000000
Const GENERIC_WRITE = &H40000000
Const OPEN_EXISTING = 3

Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal NOlpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Declare Function EscapeCommFunction Lib "kernel32" (ByVal nCid As Long, ByVal nFunc As Long) As Long
Declare Function GetCommModemStatus Lib "kernel32" (ByVal hFile As Long, lpModemStat As Long) As Long

Dim nCid As Long

Function OPENCOM(ByVal lpDef As String) As Integer
  nCid = CreateFile(Left(lpDef, 4), GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0)
  If nCid > 0 Then OPENCOM = nCid Else OPENCOM = 0
End Function
 
Sub CLOSECOM()
   x = CloseHandle(nCid)
End Sub
Sub DTR(Status As Integer)
  If Status = 1 Then EscapeCommFunction nCid, SETDTR Else: EscapeCommFunction nCid, CLRDTR
End Sub
Sub RTS(Status As Integer)
  If Status = 1 Then EscapeCommFunction nCid, SETRTS Else: EscapeCommFunction nCid, CLRRTS
End Sub
Sub TXD(Status As Integer)
  If Status = 1 Then EscapeCommFunction nCid, SETBREAK Else: EscapeCommFunction nCid, CLRBREAK
End Sub
Function CTS() As Integer
  Dim mask As Long
  GetCommModemStatus nCid, mask
  If (mask And MS_CTS_ON) = MS_CTS_ON Then CTS = 1 Else CTS = 0
End Function
Function DSR() As Integer
  Dim mask As Long
  GetCommModemStatus nCid, mask
  If (mask And MS_DSR_ON) = MS_DSR_ON Then DSR = 1 Else DSR = 0
End Function
Function RI() As Integer
  Dim mask As Long
  GetCommModemStatus nCid, mask
  If (mask And MS_RING_ON) = MS_RING_ON Then RI = 1 Else RI = 0
End Function
Function DCD() As Integer
  Dim mask As Long
  GetCommModemStatus nCid, mask
  If (mask And MS_RLSD_ON) = MS_RLSD_ON Then DCD = 1 Else DCD = 0
End Function
Function Inputs() As Integer
  Dim mask As Long
  GetCommModemStatus nCid, mask
  Inputs = (Int(mask / 16)) And 15
End Function
