library RS232;

uses Windows, SysUtils, Classes;
var  SaveExit: Pointer;
     PortHandle: Array[1..4] of THandle;
     StartTime: Int64;
     TimeUnit: Real = 0.000838096515;

function OPENCOM (COMnr,Baud,Parity,Bits,Stop,Tout,Buffer:Integer): Integer; stdcall;
var PortStr:String;
    DCB: TDCB;
    TimeOut:TCOMMTIMEOUTS;
begin
   if PortHandle[COMnr] > 0 then CloseHandle(PortHandle[ComNr]);
   PortStr := 'COM' + Chr(48+ComNr);
   PortHandle[COMnr]:=CreateFile(PChar(PortStr),GENERIC_READ or GENERIC_WRITE,0,NIL,OPEN_EXISTING,0,0);
   SetupComm(PortHandle[COMNr],Buffer,Buffer);
   GetCommState(PortHandle[COMNr],DCB);
   DCB.Flags := 1;
   DCB.BaudRate:=Baud;
   DCB.ByteSize:=Bits;
   DCB.StopBits:=Stop and 2;
   DCB.Parity:=Parity;
   if SetCommState(PortHandle[ComNr],DCB)then OPENCOM :=COMnr else OPENCOM :=0;
   TimeOut.ReadIntervalTimeout:=1;
   TimeOut.ReadTotalTimeoutMultiplier:=1;
   TimeOut.ReadTotalTimeoutConstant:=Tout;
   TimeOut.WriteTotalTimeoutMultiplier:=2;
   TimeOut.WriteTotalTimeoutConstant:=Tout;
   SetCommTimeouts(PortHandle[COMnr],TimeOut);
end;

procedure CLOSECOM(ComNr:Integer); stdcall;
begin
    CloseHandle(PortHandle[ComNr]);
    PortHandle[COMnr] := 0;
end;

procedure SENDBYTE (ComNr,Dat: Integer); stdcall;
var BytesWritten: DWord;
begin
 WriteFile(PortHandle[COMnr],Dat,1,BytesWritten,NIL);
END;

function READBYTE(COMnr: Integer): Integer; stdcall;
var Dat: Byte;
    BytesRead: DWORD;
begin
 ReadFile(PortHandle[COMnr],Dat,1,BytesRead,NIL);
 if BytesRead = 1 then Result:=Dat else Result := -1;
end;

procedure DTR(COMnr,State:integer); stdcall;
begin
 if (State=0) then EscapeCommFunction(PortHandle[COMnr],CLRDTR)
 else EscapeCommFunction(PortHandle[COMnr],SETDTR);
end;

procedure RTS(COMnr,State:integer); stdcall;
begin
 if (State=0) then EscapeCommFunction(PortHandle[COMnr],CLRRTS)
 else EscapeCommFunction(PortHandle[COMnr],SETRTS);
end;

procedure TXD(COMnr,State:integer); stdcall;
begin
 if (State=0)then ClearCommBreak(PortHandle[COMnr])
  else SetCommBreak(PortHandle[COMnr]);
end;

function CTS(COMnr: Integer):Integer; stdcall;
Var mask:Dword;
begin
     GetCommModemStatus(PortHandle[COMnr],mask);
     if (mask and MS_CTS_ON)=0 then result:=0 else result:=1;
end;

function DSR(COMnr: Integer):Integer; stdcall;
Var mask:Dword;
begin
     GetCommModemStatus(PortHandle[COMnr],mask);
     if (mask and MS_DSR_ON)=0 then result:=0 else result:=1;
end;

function RI(COMnr: Integer):Integer; stdcall;
Var mask:Dword;
begin
     GetCommModemStatus(PortHandle[COMnr],mask);
     if (mask and MS_RING_ON)=0 then result:=0 else result:=1;
end;

function DCD(COMnr: Integer):Integer; stdcall;
Var mask:Dword;
begin
     GetCommModemStatus(PortHandle[COMnr],mask);
     if (mask and MS_RLSD_ON)=0 then result:=0 else result:=1;
end;

function INPUTS(COMnr: Integer):Integer; stdcall;
Var mask:Dword;
begin
     GetCommModemStatus(PortHandle[COMnr],mask);
     INPUTS := (mask div 16) and 15;
end;

procedure TIMEINIT(); stdcall;
var f: Int64;
begin
  QueryPerformanceFrequency(f);
  TimeUnit := 1000 / f;
  QueryPerformanceCounter(StartTime)
end;

function TIMEREAD(): Real; stdcall;
var t: Int64;
begin
  QueryPerformanceCounter(t);
  TIMEREAD := TimeUnit*(t - StartTime) ;
end;

procedure DELAY(DelayTime: Real); stdcall;
var TimeStart: real;
begin
  TimeStart := TIMEREAD;
  while TIMEREAD < (TimeStart + DelayTime) do;
end;

procedure REALTIME(); stdcall;
begin
 SetPriorityClass (GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
end;

procedure NORMALTIME(); stdcall;
begin
  SetPriorityClass (GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
end;

procedure LibExit;
var n: Integer;
begin
  for n := 1 to 4 do begin
    if PortHandle[n]> 0 then Closecom (n);
  end;
  ExitProc := SaveExit;
end;

procedure LibraryProc(Reason: Integer);
var n: Integer;
begin
  for n := 1 to 4 do begin
    if PortHandle[n]> 0 then Closecom (n);
  end;
end;


exports
  OPENCOM index 1,
  CLOSECOM index 2,
  SENDBYTE index 3,
  READBYTE index 4,
  DTR index 5,
  RTS index 6,
  TXD index 7,
  CTS index 8,
  DSR index 9,
  RI  index 10,
  DCD index 11,
  INPUTS index 12,
  TIMEINIT index 13,
  TIMEREAD index 14,
  DELAY index 15,
  REALTIME index 16,
  NORMALTIME index 17;

begin
  SaveExit := ExitProc;
  ExitProc := @LibExit;
  DLLProc := @LibraryProc;
end.

